<?php
/**
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	Docman2Edocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');
/**
 * Docman2EDocman Component Migrate Model
 *
 * @package		Joomla
 * @subpackage	Docman2EDocman
 * @since 1.5
 */
class Docman2EdocmanModelMigrate extends JModelLegacy 
{					
	function processMigrate() {	
		
		require_once JPATH_ADMINISTRATOR.'/components/com_edocman/table/category.php' ;
		require_once JPATH_ADMINISTRATOR.'/components/com_edocman/table/document.php' ;
		require_once JPATH_COMPONENT.'/helpers/docman2edocman.php' ;
		$db = & JFactory::getDbo() ;
		$config = Docman2EDocmanHelper::getConfig() ;
        $query = $db->getQuery(true);
		$options = array();
		$options['host']        = $config->host ? $config->host : 'localhost';
		$options['user']        = $config->user ? $config->user : 'root';
		$options['password']    = $config->password ? $config->password : '';
		$options['database']    = $config->database ? $config->database : '' ;
		$options['prefix']      = $config->prefix ? $config->prefix : 'jos_';

		$docmanDb = JDatabase::getInstance($options);		
		if ($docmanDb->getErrorNum() > 0) {
			JError::raiseError(500 , 'JDatabase::getInstance: Could not connect to database <br />' . 'joomla.library:'.$db->getErrorNum().' - '.$db->getErrorMsg() );
		}

		if($options['database'] == ""){
			JError::raiseError(500 , 'No Database selection' );
		}
				
		//Finaly, migrate categories
		$sql            = 'SELECT * FROM #__docman_categories';
		$docmanDb->setQuery($sql) ;
		$rows           = $docmanDb->loadObjectList();
		$rowCat         = JTable::getInstance('Category', 'EdocmanTable') ;
		$mappings       = array() ;
		$parents        = array() ;
		for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
			$row        = $rows[$i] ;
			$name       = $db->quote($row->title) ;
			//Check to see whether this categories existed in the system or not
			$sql = 'SELECT id FROM #__edocman_categories WHERE title='.$name;
			$db->setQuery($sql);
			$catId = $db->loadResult() ;
			if (!$catId) {
				$data['id']                 = 0 ;
				$data['title']              = $row->title ;
				$data['description']        = $row->description ;
				$data['published']          = $row->enabled ;
                $alias                      = $row->slug;
                $query->clear();
                $query->select('count(id)')->from('#__edocman_categories')->where('alias like "'.$alias.'"');
                $db->setQuery($query);
                $count                      = $db->loadResult();
                if($count > 0){
                    $count                  = (int)$count + 1;
                    $alias                  = $alias."-".$count;
                }
                $data['alias']              = $alias;

				$rowCat->bind($data);
				$rowCat->store();
				$catId                      = $rowCat->id ;
			}
            //old DOCman version
			//$mappings[$row->id]             = $catId ;
            //new DOCman version
            $mappings[$row->docman_category_id]             = $catId ;
            //find parent of this category
            //old DOCman version
            /*
			if ($row->parent_id) {
				$parents[$row->id]          = $row->parent_id ;
			}
            */
            //new DOCman version
            $query->clear();
            $query->select('ancestor_id')->from('#__docman_category_relations')->where('descendant_id = "'.$row->docman_category_id.'" and ancestor_id <> "'.$row->docman_category_id.'"');
            $db->setQuery($query);
            $parent_id = $db->loadResult();
            //if($parent_id > 0){
            $parents[$row->docman_category_id]          = (int)$parent_id;
            //}
		}

       // die();
		foreach ($parents as $child => $parent) {
			$newChild                   = $mappings[$child] ;
			$newParent                  = $mappings[$parent] ;
			$sql                        = "UPDATE #__edocman_categories SET parent_id='".$newParent."' WHERE id='".$newChild."'";
			$db->setQuery($sql) ;
			$db->query();
		}

		//Now migrate data for Document
		$sql                            = 'SELECT a.* FROM #__docman_documents AS a ' ;
		$docmanDb->setQuery($sql) ;
		$rows = $docmanDb->loadObjectList();
		$rowDoc                         =  $this->getTable('Document', 'EDocmanTable');
		for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
			$row                        = $rows[$i] ;
			$data                       = array();
			$data['id']                 = 0 ;
			$data['title']              = $row->title ;
			$data['short_description']  = $data['description'] = $row->description ;
			$data['image']              = $row->image ;
			$data['filename']           = $data['original_filename'] = $row->storage_path ;
			$data['published']          = $row->enabled ;
			$data['created_time']       = $row->created_on ;
			$data['modified_time']      = date('Y-m-d H:i:s') ;
			$data['downloads']          = $row->hits ;
            //old DOCman version
			//$categoryId                 = $mappings[$row->catid] ;
            //new DOCMan version
            $categoryId                 = $mappings[$row->docman_category_id] ;

			$_POST['jform']['category_id'] = (int)$categoryId ;
            $alias                      = $row->slug;
            $query->clear();
            $query->select('count(id)')->from('#__edocman_documents')->where('alias like "'.$alias.'"');
            $db->setQuery($query);
            $count = $db->loadResult();
            if($count > 0){
                $count                  = (int)$count + 1;
                $alias                  = $alias."-".$count;
            }
            $data['alias']              = $alias;
			$rowDoc->bind($data);
			$rowDoc->store();

            //assign document to category
            $query                      = $db->getQuery(true);
            $query->insert('#__edocman_document_category')->columns(array('id','document_id','category_id','is_main_category'))->values(implode(",",array('NULL',$rowDoc->id,$categoryId,'1')));
            $db->setQuery($query);
            $db->execute();
		}
		return true ;
	}	
}